
// Include Libraries
#include "Arduino.h"
#include "BTHC05.h"
#include "PiezoSpeaker.h"



#define BTHC05_PIN_TXD	11
#define BTHC05_PIN_RXD	10
#define PIEZOSPEAKER_3V3_PIN_SIG	5




unsigned int piezoSpeaker_3v3HoorayLength          = 6;                                                      // amount of notes in melody
unsigned int piezoSpeaker_3v3HoorayMelody[]        = {NOTE_C4, NOTE_E4, NOTE_G4, NOTE_C5, NOTE_G4, NOTE_C5}; // list of notes. List length must match HoorayLength!
unsigned int piezoSpeaker_3v3HoorayNoteDurations[] = {8      , 8      , 8      , 4      , 8      , 4      }; // note durations; 4 = quarter note, 8 = eighth note, etc. List length must match HoorayLength!

BTHC05 bthc05(BTHC05_PIN_RXD,BTHC05_PIN_TXD);
PiezoSpeaker piezoSpeaker_3v3(PIEZOSPEAKER_3V3_PIN_SIG);



const int timeout = 10000;       
char menuOption = 0;
long time0;


void setup() 
{
   
    Serial.begin(9600);
    while (!Serial) ; 
    Serial.println("start");
    
    bthc05.begin(9600);

    bthc05.println("Bluetooth On....");
    menuOption = menu();
    
}


void loop() 
{
    
    
    if(menuOption == '1') {
   
    String bthc05Str = "";

    if (bthc05.available())
    {

    bthc05Str = bthc05.readStringUntil('\n');

    Serial.print("BT Raw Data: ");
    Serial.println(bthc05Str);
    }
  
    bthc05.println("PUT YOUR SENSOR DATA HERE");
    }
    else if(menuOption == '2') {

    piezoSpeaker_3v3.playMelody(piezoSpeaker_3v3HoorayLength, piezoSpeaker_3v3HoorayMelody, piezoSpeaker_3v3HoorayNoteDurations); 
    delay(500);   
    }
    
    if (millis() - time0 > timeout)
    {
        menuOption = menu();
    }
    
}




char menu()
{

    Serial.println(F("\nWhich component would you like to test?"));
    Serial.println(F("(1) HC - 05 Bluetooth Serial Module"));
    Serial.println(F("(2) Piezo Speaker"));
    Serial.println(F("(menu) send anything else or press on board reset button\n"));
    while (!Serial.available());

    
    while (Serial.available()) 
    {
        char c = Serial.read();
        if (isAlphaNumeric(c)) 
        {   
            
            if(c == '1') 
    			Serial.println(F("Now Testing HC - 05 Bluetooth Serial Module"));
    		else if(c == '2') 
    			Serial.println(F("Now Testing Piezo Speaker"));
            else
            {
                Serial.println(F("illegal input!"));
                return 0;
            }
            time0 = millis();
            return c;
        }
    }
}

